// root events
export const ALL_CONFIGS_LOADED = 'ALL_CONFIGS_LOADED';

// shop
export const EVENT_UI_ADD_TO_CART = 'EVENT_UI_ADD_TO_CART';
export const EVENT_TAKE_SCREENSHOT = 'EVENT_TAKE_SCREENSHOT';

// payload events
export const EVENT_PAYLOAD_START = 'EVENT_PAYLOAD_START';
export const EVENT_PAYLOAD_FINISH = 'EVENT_PAYLOAD_FINISH';
export const EVENT_PAYLOAD_LIST = 'EVENT_PAYLOAD_LIST';
export const EVENT_SILENT_LOAD = 'EVENT_SILENT_LOAD';
export const EVENT_STATE_WHEN_READY = 'EVENT_STATE_WHEN_READY';
export const EVENT_STATE_LOADING = 'EVENT_STATE_LOADING';
export const EVENT_STATE_READY = 'EVENT_STATE_READY';
export const EVENT_STATE_VISIBLE = 'EVENT_STATE_VISIBLE';
export const EVENT_STATE_OUTRO = 'EVENT_STATE_OUTRO';

// progress bar & outro
export const EVENT_PROGRESS_START = 'EVENT_PROGRESS_START';
export const EVENT_PROGRESS_ADD = 'EVENT_PROGRESS_ADD';
export const EVENT_ADJUST_PROGRESS_CONFIG = 'EVENT_ADJUST_PROGRESS_CONFIG';
export const EVENT_PROGRESS_BAR_STARTED = 'EVENT_PROGRESS_BAR_STARTED';
export const EVENT_OUTRO_START = 'EVENT_OUTRO_START';
export const EVENT_OUTRO_ADD = 'EVENT_OUTRO_ADD';

// state manager
export const EVENT_CUSTOMIZER_LOADING = 'EVENT_CUSTOMIZER_LOADING';
export const EVENT_CUSTOMIZER_SCENE_READY = 'EVENT_CUSTOMIZER_SCENE_READY';
export const EVENT_CUSTOMIZER_READY = 'EVENT_CUSTOMIZER_READY';
export const EVENT_CUSTOMIZER_VISIBLE = 'EVENT_CUSTOMIZER_VISIBLE';
export const EVENT_RESUME_CUSTOMIZER = 'EVENT_RESUME_CUSTOMIZER';
export const EVENT_UI_CHANGE_STEP = 'EVENT_UI_CHANGE_STEP';

export const EVENT_DYNAMIC_PROPERTY_CREATION = 'EVENT_DYNAMIC_PROPERTY_CREATION';
export const EVENT_DYNAMIC_PROPERTY_UPDATE = 'EVENT_DYNAMIC_PROPERTY_UPDATE';
export const EVENT_DYNAMIC_PROPERTY_UPDATED = 'EVENT_DYNAMIC_PROPERTY_UPDATED';

// customization steps
export const EVENT_CUSTOMIZE_HIDDEN = 'EVENT_CUSTOMIZE_HIDDEN';
export const EVENT_CUSTOMIZE_STEP_1 = 'EVENT_CUSTOMIZE_STEP_1';
export const EVENT_CUSTOMIZE_STEP_2 = 'EVENT_CUSTOMIZE_STEP_2';
export const EVENT_CUSTOMIZE_UPLOAD = 'EVENT_CUSTOMIZE_UPLOAD';
export const EVENT_LABEL_UI_STEP_1 = 'EVENT_LABEL_UI_STEP_1';
export const EVENT_LABEL_UI_STEP_2 = 'EVENT_LABEL_UI_STEP_2';
export const EVENT_UPDATE_CANVAS = 'EVENT_UPDATE_CANVAS';
export const EVENT_UPDATE_LABEL_MATERIAL = 'EVENT_UPDATE_LABEL_MATERIAL';

// product config
export const EVENT_CREATE_MODEL = 'EVENT_CREATE_MODEL';

// 2d canvas
export const EVENT_UPDATE_2D_CANVAS_IMAGE = 'EVENT_UPDATE_2D_CANVAS_IMAGE';
export const EVENT_LABEL_IMAGE_SCALING = 'EVENT_LABEL_IMAGE_SCALING';
export const EVENT_GET_LABEL_IMAGE = 'EVENT_GET_LABEL_IMAGE';
export const EVENT_GET_LABEL_CANVAS = 'EVENT_GET_LABEL_CANVAS';
export const EVENT_GET_PART_TO_CUSTOMIZE = 'EVENT_GET_PART_TO_CUSTOMIZE';
export const EVENT_RESET_SCALE = 'EVENT_RESET_SCALE';
export const EVENT_PREVIEW_LABEL = 'EVENT_PREVIEW_LABEL';
export const EVENT_UPDATE_PARTS_MATERIALS = 'EVENT_UPDATE_PARTS_MATERIALS';
export const EVENT_ADJUST_CANVAS = 'EVENT_ADJUST_CANVAS';
export const EVENT_CREATE_MASK_CANVAS = 'EVENT_CREATE_MASK_CANVAS';
export const EVENT_DESTROY_MASK_CANVAS = 'EVENT_DESTROY_MASK_CANVAS';
export const EVENT_UPDATE_MODEL_LABEL = 'EVENT_UPDATE_MODEL_LABEL';

// model config

// three.js
export const EVENT_ADD_TO_SCENE = 'EVENT_ADD_TO_SCENE';
export const EVENT_REMOVE_FROM_SCENE = 'EVENT_REMOVE_FROM_SCENE';
export const EVENT_GET_THREE_SCENE = 'EVENT_GET_THREE_SCENE';
export const EVENT_GET_THREE_CAMERA = 'EVENT_GET_THREE_CAMERA';
export const EVENT_GET_CAMERA_INITIAL_POSITION = 'EVENT_GET_CAMERA_INITIAL_POSITION';
export const EVENT_GET_THREE_RENDERER = 'EVENT_GET_THREE_RENDERER';
export const EVENT_ADD_TO_RENDERER = 'EVENT_ADD_TO_RENDERER';
export const EVENT_GET_THREE_CANVAS = 'EVENT_GET_THREE_CANVAS';
export const EVENT_GET_PRODUCT_POSITION = 'EVENT_GET_PRODUCT_POSITION';
export const EVENT_TRIGGER_RENDER = 'EVENT_TRIGGER_RENDER';
export const EVENT_GET_PIN_POSITION = 'EVENT_GET_PIN_POSITION';
export const EVENT_CAMERA_ANIMATION = 'EVENT_CAMERA_ANIMATION';
export const EVENT_CAMERA_RESET_ANIMATION = 'EVENT_CAMERA_RESET_ANIMATION';

// model & components
export const EVENT_ASSIGN_PARTS = 'EVENT_ASSIGN_PARTS';
export const EVENT_PREPARE_PRODUCT_FACADE = 'EVENT_PREPARE_PRODUCT_FACADE';
export const EVENT_TEXTURE_CHANGE = 'EVENT_TEXTURE_CHANGE';
export const EVENT_GET_MODEL = 'EVENT_GET_MODEL';
export const EVENT_GET_MODEL_DIMENSIONS = 'EVENT_GET_MODEL_DIMENSIONS';
export const EVENT_GET_MODEL_PARTS = 'EVENT_GET_MODEL_PARTS';
export const EVENT_MODEL_READY = 'EVENT_MODEL_READY';
export const EVENT_TEXTURES_APPLIED = 'EVENT_TEXTURES_APPLIED';
export const EVENT_GET_MODEL_NAME = 'EVENT_GET_MODEL_NAME';
export const EVENT_GET_COMPONENT_BY_KEY = 'EVENT_GET_COMPONENT_BY_KEY'


// materials/textures
export const EVENT_BUILD_MATERIAL = 'EVENT_BUILD_MATERIAL';
export const EVENT_UPDATE_MATERIAL = 'EVENT_UPDATE_MATERIAL';

// scene/extras
export const EVENT_GET_GROUND_CONFIG = 'EVENT_GET_GROUND_CONFIG';
export const EVENT_GET_CANVAS_SIZE = 'EVENT_GET_CANVAS_SIZE';

// controls
export const EVENT_AFTER_CONTROLS_UPDATE = 'EVENT_AFTER_CONTROLS_UPDATE';
export const TRIGGER_MANUAL_CONTROLS_UPDATE = 'TRIGGER_MANUAL_CONTROLS_UPDATE';
export const EVENT_GET_CONTROLS = 'EVENT_GET_CONTROLS';
export const EVENT_MOUSE_PRESS = 'EVENT_MOUSE_PRESS';
export const EVENT_MOUSE_RELEASE = 'EVENT_MOUSE_RELEASE';
export const EVENT_TRIGGER_ZOOM_IN = 'EVENT_TRIGGER_ZOOM_IN';
export const EVENT_TRIGGER_ZOOM_OUT = 'EVENT_TRIGGER_ZOOM_OUT';

//exporter
export const EVENT_COLLECT_PRODUCT_INFO = 'EVENT_COLLECT_PRODUCT_INFO';
export const EVENT_GET_PRODUCT_IS_CUSTOMIZED = 'EVENT_GET_PRODUCT_IS_CUSTOMIZED';
export const EVENT_COLORS_DATA_FOR_EXPORT = 'EVENT_COLORS_DATA_FOR_EXPORT';

// order manager
export const EVENT_SEND_PRODUCT_INFO = 'EVENT_SEND_PRODUCT_INFO';

// product types
export const EVENT_GET_PRODUCT_TYPE = 'EVENT_GET_PRODUCT_TYPE';

// not events - prelaoder file types
export const TYPE_TEXTURE = 'texture';
export const TYPE_IMAGE = 'image';
export const TYPE_GLB = 'glb';